// Copyright 2021-2022 Axiom-Team
//
// This file is part of Duniter-v2S.
//
// Duniter-v2S is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, version 3 of the License.
//
// Duniter-v2S is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with Duniter-v2S. If not, see <https://www.gnu.org/licenses/>.

//! Autogenerated weights for `pallet_authority_members`
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2023-06-08, STEPS: `5`, REPEAT: `2`, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! WORST CASE MAP SIZE: `1000000`
//! HOSTNAME: `benjamin-xps139380`, CPU: `Intel(R) Core(TM) i7-8565U CPU @ 1.80GHz`
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("gdev-benchmark"), DB CACHE: 1024

// Executed Command:
// target/release/duniter
// benchmark
// pallet
// --chain=gdev-benchmark
// --steps=5
// --repeat=2
// --pallet=pallet-authority-members
// --extrinsic=*
// --execution=wasm
// --wasm-execution=compiled
// --heap-pages=4096
// --header=./file_header.txt
// --output=./runtime/common/src/weights/

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(missing_docs)]

use frame_support::{traits::Get, weights::Weight};
use core::marker::PhantomData;

/// Weight functions for `pallet_authority_members`.
pub struct WeightInfo<T>(PhantomData<T>);
impl<T: frame_system::Config> pallet_authority_members::WeightInfo for WeightInfo<T> {
	/// Storage: Identity IdentityIndexOf (r:1 w:0)
	/// Proof Skipped: Identity IdentityIndexOf (max_values: None, max_size: None, mode: Measured)
	/// Storage: SmithMembership Membership (r:1 w:0)
	/// Proof Skipped: SmithMembership Membership (max_values: None, max_size: None, mode: Measured)
	/// Storage: AuthorityMembers Members (r:1 w:0)
	/// Proof Skipped: AuthorityMembers Members (max_values: None, max_size: None, mode: Measured)
	/// Storage: AuthorityMembers OutgoingAuthorities (r:1 w:1)
	/// Proof Skipped: AuthorityMembers OutgoingAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers IncomingAuthorities (r:1 w:0)
	/// Proof Skipped: AuthorityMembers IncomingAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers OnlineAuthorities (r:1 w:0)
	/// Proof Skipped: AuthorityMembers OnlineAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers AuthoritiesCounter (r:1 w:1)
	/// Proof Skipped: AuthorityMembers AuthoritiesCounter (max_values: Some(1), max_size: None, mode: Measured)
	fn go_offline() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `632`
		//  Estimated: `4097`
		// Minimum execution time: 99_427_000 picoseconds.
		Weight::from_parts(105_315_000, 0)
			.saturating_add(Weight::from_parts(0, 4097))
			.saturating_add(T::DbWeight::get().reads(7))
			.saturating_add(T::DbWeight::get().writes(2))
	}
	/// Storage: Identity IdentityIndexOf (r:1 w:0)
	/// Proof Skipped: Identity IdentityIndexOf (max_values: None, max_size: None, mode: Measured)
	/// Storage: SmithMembership Membership (r:1 w:0)
	/// Proof Skipped: SmithMembership Membership (max_values: None, max_size: None, mode: Measured)
	/// Storage: AuthorityMembers BlackList (r:1 w:0)
	/// Proof Skipped: AuthorityMembers BlackList (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers Members (r:1 w:0)
	/// Proof Skipped: AuthorityMembers Members (max_values: None, max_size: None, mode: Measured)
	/// Storage: Session NextKeys (r:1 w:0)
	/// Proof Skipped: Session NextKeys (max_values: None, max_size: None, mode: Measured)
	/// Storage: AuthorityMembers IncomingAuthorities (r:1 w:1)
	/// Proof Skipped: AuthorityMembers IncomingAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers OutgoingAuthorities (r:1 w:0)
	/// Proof Skipped: AuthorityMembers OutgoingAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers OnlineAuthorities (r:1 w:0)
	/// Proof Skipped: AuthorityMembers OnlineAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers AuthoritiesCounter (r:1 w:1)
	/// Proof Skipped: AuthorityMembers AuthoritiesCounter (max_values: Some(1), max_size: None, mode: Measured)
	fn go_online() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `1022`
		//  Estimated: `4487`
		// Minimum execution time: 120_665_000 picoseconds.
		Weight::from_parts(130_931_000, 0)
			.saturating_add(Weight::from_parts(0, 4487))
			.saturating_add(T::DbWeight::get().reads(9))
			.saturating_add(T::DbWeight::get().writes(2))
	}
	/// Storage: Identity IdentityIndexOf (r:1 w:0)
	/// Proof Skipped: Identity IdentityIndexOf (max_values: None, max_size: None, mode: Measured)
	/// Storage: SmithMembership Membership (r:1 w:0)
	/// Proof Skipped: SmithMembership Membership (max_values: None, max_size: None, mode: Measured)
	/// Storage: System Account (r:1 w:0)
	/// Proof: System Account (max_values: None, max_size: Some(161), added: 2636, mode: MaxEncodedLen)
	/// Storage: Session NextKeys (r:1 w:1)
	/// Proof Skipped: Session NextKeys (max_values: None, max_size: None, mode: Measured)
	/// Storage: Session KeyOwner (r:4 w:0)
	/// Proof Skipped: Session KeyOwner (max_values: None, max_size: None, mode: Measured)
	/// Storage: Session CurrentIndex (r:1 w:0)
	/// Proof Skipped: Session CurrentIndex (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers Members (r:1 w:1)
	/// Proof Skipped: AuthorityMembers Members (max_values: None, max_size: None, mode: Measured)
	/// Storage: AuthorityMembers MustRotateKeysBefore (r:1 w:1)
	/// Proof Skipped: AuthorityMembers MustRotateKeysBefore (max_values: None, max_size: None, mode: Measured)
	fn set_session_keys() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `1750`
		//  Estimated: `12640`
		// Minimum execution time: 166_507_000 picoseconds.
		Weight::from_parts(181_777_000, 0)
			.saturating_add(Weight::from_parts(0, 12640))
			.saturating_add(T::DbWeight::get().reads(11))
			.saturating_add(T::DbWeight::get().writes(3))
	}
	/// Storage: AuthorityMembers Members (r:1 w:1)
	/// Proof Skipped: AuthorityMembers Members (max_values: None, max_size: None, mode: Measured)
	/// Storage: AuthorityMembers OnlineAuthorities (r:1 w:1)
	/// Proof Skipped: AuthorityMembers OnlineAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers OutgoingAuthorities (r:1 w:1)
	/// Proof Skipped: AuthorityMembers OutgoingAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers AuthoritiesCounter (r:1 w:1)
	/// Proof Skipped: AuthorityMembers AuthoritiesCounter (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: AuthorityMembers IncomingAuthorities (r:1 w:1)
	/// Proof Skipped: AuthorityMembers IncomingAuthorities (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: Session NextKeys (r:1 w:1)
	/// Proof Skipped: Session NextKeys (max_values: None, max_size: None, mode: Measured)
	/// Storage: System Account (r:1 w:1)
	/// Proof: System Account (max_values: None, max_size: Some(161), added: 2636, mode: MaxEncodedLen)
	/// Storage: SmithMembership Membership (r:1 w:1)
	/// Proof Skipped: SmithMembership Membership (max_values: None, max_size: None, mode: Measured)
	/// Storage: SmithMembership CounterForMembership (r:1 w:1)
	/// Proof: SmithMembership CounterForMembership (max_values: Some(1), max_size: Some(4), added: 499, mode: MaxEncodedLen)
	/// Storage: SmithMembership MembershipsExpireOn (r:1 w:1)
	/// Proof Skipped: SmithMembership MembershipsExpireOn (max_values: None, max_size: None, mode: Measured)
	/// Storage: Session KeyOwner (r:0 w:4)
	/// Proof Skipped: Session KeyOwner (max_values: None, max_size: None, mode: Measured)
	fn remove_member() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `975`
		//  Estimated: `4440`
		// Minimum execution time: 222_719_000 picoseconds.
		Weight::from_parts(240_189_000, 0)
			.saturating_add(Weight::from_parts(0, 4440))
			.saturating_add(T::DbWeight::get().reads(10))
			.saturating_add(T::DbWeight::get().writes(14))
	}
	/// Storage: AuthorityMembers BlackList (r:1 w:1)
	/// Proof Skipped: AuthorityMembers BlackList (max_values: Some(1), max_size: None, mode: Measured)
	fn remove_member_from_blacklist() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `218`
		//  Estimated: `1703`
		// Minimum execution time: 41_963_000 picoseconds.
		Weight::from_parts(47_577_000, 0)
			.saturating_add(Weight::from_parts(0, 1703))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
}
