// Copyright 2021-2022 Axiom-Team
//
// This file is part of Duniter-v2S.
//
// Duniter-v2S is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, version 3 of the License.
//
// Duniter-v2S is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with Duniter-v2S. If not, see <https://www.gnu.org/licenses/>.

//! Autogenerated weights for `pallet_duniter_account`
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2023-06-08, STEPS: `5`, REPEAT: `2`, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! WORST CASE MAP SIZE: `1000000`
//! HOSTNAME: `benjamin-xps139380`, CPU: `Intel(R) Core(TM) i7-8565U CPU @ 1.80GHz`
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("gdev-benchmark"), DB CACHE: 1024

// Executed Command:
// target/release/duniter
// benchmark
// pallet
// --chain=gdev-benchmark
// --steps=5
// --repeat=2
// --pallet=*
// --extrinsic=*
// --execution=wasm
// --wasm-execution=compiled
// --heap-pages=4096
// --header=./file_header.txt
// --output=./runtime/common/src/weights/

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(missing_docs)]

use frame_support::{traits::Get, weights::Weight};
use core::marker::PhantomData;

/// Weight functions for `pallet_duniter_account`.
pub struct WeightInfo<T>(PhantomData<T>);
impl<T: frame_system::Config> pallet_duniter_account::WeightInfo for WeightInfo<T> {
	/// Storage: System Account (r:1 w:0)
	/// Proof: System Account (max_values: None, max_size: Some(126), added: 2601, mode: MaxEncodedLen)
	fn unlink_identity() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `0`
		//  Estimated: `3591`
		// Minimum execution time: 95_130_000 picoseconds.
		Weight::from_parts(110_501_000, 0)
			.saturating_add(Weight::from_parts(0, 3591))
			.saturating_add(T::DbWeight::get().reads(1))
	}
	/// Storage: Account PendingNewAccounts (r:1 w:1)
	/// Proof Skipped: Account PendingNewAccounts (max_values: None, max_size: None, mode: Measured)
	/// Storage: ProvideRandomness RequestIdProvider (r:1 w:1)
	/// Proof Skipped: ProvideRandomness RequestIdProvider (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: ProvideRandomness RequestsIds (r:1 w:1)
	/// Proof Skipped: ProvideRandomness RequestsIds (max_values: None, max_size: None, mode: Measured)
	/// Storage: ProvideRandomness CounterForRequestsIds (r:1 w:1)
	/// Proof: ProvideRandomness CounterForRequestsIds (max_values: Some(1), max_size: Some(4), added: 499, mode: MaxEncodedLen)
	/// Storage: Babe EpochIndex (r:1 w:0)
	/// Proof: Babe EpochIndex (max_values: Some(1), max_size: Some(8), added: 503, mode: MaxEncodedLen)
	/// Storage: ProvideRandomness NexEpochHookIn (r:1 w:0)
	/// Proof Skipped: ProvideRandomness NexEpochHookIn (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: ProvideRandomness RequestsReadyAtEpoch (r:1 w:1)
	/// Proof Skipped: ProvideRandomness RequestsReadyAtEpoch (max_values: None, max_size: None, mode: Measured)
	/// Storage: Account PendingRandomIdAssignments (r:0 w:1)
	/// Proof Skipped: Account PendingRandomIdAssignments (max_values: None, max_size: None, mode: Measured)
	/// The range of component `i` is `[0, 1]`.
	fn on_initialize_sufficient(i: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `42 + i * (309 ±0)`
		//  Estimated: `3816 + i * (309 ±0)`
		// Minimum execution time: 13_976_000 picoseconds.
		Weight::from_parts(20_107_000, 0)
			.saturating_add(Weight::from_parts(0, 3816))
			// Standard Error: 5_235_621
			.saturating_add(Weight::from_parts(66_222_000, 0).saturating_mul(i.into()))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().reads((6_u64).saturating_mul(i.into())))
			.saturating_add(T::DbWeight::get().writes((6_u64).saturating_mul(i.into())))
			.saturating_add(Weight::from_parts(0, 309).saturating_mul(i.into()))
	}
	/// Storage: Account PendingNewAccounts (r:1 w:1)
	/// Proof Skipped: Account PendingNewAccounts (max_values: None, max_size: None, mode: Measured)
	/// Storage: ProvideRandomness RequestIdProvider (r:1 w:1)
	/// Proof Skipped: ProvideRandomness RequestIdProvider (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: ProvideRandomness RequestsIds (r:1 w:1)
	/// Proof Skipped: ProvideRandomness RequestsIds (max_values: None, max_size: None, mode: Measured)
	/// Storage: ProvideRandomness CounterForRequestsIds (r:1 w:1)
	/// Proof: ProvideRandomness CounterForRequestsIds (max_values: Some(1), max_size: Some(4), added: 499, mode: MaxEncodedLen)
	/// Storage: Babe EpochIndex (r:1 w:0)
	/// Proof: Babe EpochIndex (max_values: Some(1), max_size: Some(8), added: 503, mode: MaxEncodedLen)
	/// Storage: ProvideRandomness NexEpochHookIn (r:1 w:0)
	/// Proof Skipped: ProvideRandomness NexEpochHookIn (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: ProvideRandomness RequestsReadyAtEpoch (r:1 w:1)
	/// Proof Skipped: ProvideRandomness RequestsReadyAtEpoch (max_values: None, max_size: None, mode: Measured)
	/// Storage: Account PendingRandomIdAssignments (r:0 w:1)
	/// Proof Skipped: Account PendingRandomIdAssignments (max_values: None, max_size: None, mode: Measured)
	/// The range of component `i` is `[0, 1]`.
	fn on_initialize_with_balance(i: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `42 + i * (309 ±0)`
		//  Estimated: `3816 + i * (309 ±0)`
		// Minimum execution time: 13_885_000 picoseconds.
		Weight::from_parts(18_835_500, 0)
			.saturating_add(Weight::from_parts(0, 3816))
			// Standard Error: 5_218_700
			.saturating_add(Weight::from_parts(145_659_000, 0).saturating_mul(i.into()))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().reads((6_u64).saturating_mul(i.into())))
			.saturating_add(T::DbWeight::get().writes((6_u64).saturating_mul(i.into())))
			.saturating_add(Weight::from_parts(0, 309).saturating_mul(i.into()))
	}
	/// Storage: Account PendingNewAccounts (r:1 w:1)
	/// Proof Skipped: Account PendingNewAccounts (max_values: None, max_size: None, mode: Measured)
	/// The range of component `i` is `[0, 1]`.
	fn on_initialize_no_balance(i: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `42 + i * (74 ±0)`
		//  Estimated: `3507 + i * (74 ±0)`
		// Minimum execution time: 14_090_000 picoseconds.
		Weight::from_parts(19_033_000, 0)
			.saturating_add(Weight::from_parts(0, 3507))
			// Standard Error: 5_117_938
			.saturating_add(Weight::from_parts(34_767_000, 0).saturating_mul(i.into()))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes((1_u64).saturating_mul(i.into())))
			.saturating_add(Weight::from_parts(0, 74).saturating_mul(i.into()))
	}
	/// Storage: Account PendingRandomIdAssignments (r:1 w:1)
	/// Proof Skipped: Account PendingRandomIdAssignments (max_values: None, max_size: None, mode: Measured)
	fn on_filled_randomness_pending() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `116`
		//  Estimated: `3581`
		// Minimum execution time: 55_833_000 picoseconds.
		Weight::from_parts(64_334_000, 0)
			.saturating_add(Weight::from_parts(0, 3581))
			.saturating_add(T::DbWeight::get().reads(1))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: Account PendingRandomIdAssignments (r:1 w:0)
	/// Proof Skipped: Account PendingRandomIdAssignments (max_values: None, max_size: None, mode: Measured)
	fn on_filled_randomness_no_pending() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `42`
		//  Estimated: `3507`
		// Minimum execution time: 11_103_000 picoseconds.
		Weight::from_parts(18_273_000, 0)
			.saturating_add(Weight::from_parts(0, 3507))
			.saturating_add(T::DbWeight::get().reads(1))
	}
}
