// Copyright 2021-2022 Axiom-Team
//
// This file is part of Duniter-v2S.
//
// Duniter-v2S is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, version 3 of the License.
//
// Duniter-v2S is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with Duniter-v2S. If not, see <https://www.gnu.org/licenses/>.

//! Autogenerated weights for `pallet_universal_dividend`
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2023-06-08, STEPS: `5`, REPEAT: `2`, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! WORST CASE MAP SIZE: `1000000`
//! HOSTNAME: `benjamin-xps139380`, CPU: `Intel(R) Core(TM) i7-8565U CPU @ 1.80GHz`
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("gdev-benchmark"), DB CACHE: 1024

// Executed Command:
// target/release/duniter
// benchmark
// pallet
// --chain=gdev-benchmark
// --steps=5
// --repeat=2
// --pallet=*
// --extrinsic=*
// --execution=wasm
// --wasm-execution=compiled
// --heap-pages=4096
// --header=./file_header.txt
// --output=./runtime/common/src/weights/

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(missing_docs)]

use frame_support::{traits::Get, weights::Weight};
use core::marker::PhantomData;

/// Weight functions for `pallet_universal_dividend`.
pub struct WeightInfo<T>(PhantomData<T>);
impl<T: frame_system::Config> pallet_universal_dividend::WeightInfo for WeightInfo<T> {
	/// Storage: Parameters ParametersStorage (r:1 w:0)
	/// Proof Skipped: Parameters ParametersStorage (max_values: Some(1), max_size: None, mode: Measured)
	fn on_initialize() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `123`
		//  Estimated: `1608`
		// Minimum execution time: 13_281_000 picoseconds.
		Weight::from_parts(22_005_000, 0)
			.saturating_add(Weight::from_parts(0, 1608))
			.saturating_add(T::DbWeight::get().reads(1))
	}
	/// Storage: Parameters ParametersStorage (r:1 w:0)
	/// Proof Skipped: Parameters ParametersStorage (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: Membership CounterForMembership (r:1 w:0)
	/// Proof: Membership CounterForMembership (max_values: Some(1), max_size: Some(4), added: 499, mode: MaxEncodedLen)
	/// Storage: UniversalDividend NextReeval (r:1 w:0)
	/// Proof: UniversalDividend NextReeval (max_values: Some(1), max_size: Some(4), added: 499, mode: MaxEncodedLen)
	/// Storage: UniversalDividend CurrentUd (r:1 w:0)
	/// Proof: UniversalDividend CurrentUd (max_values: Some(1), max_size: Some(8), added: 503, mode: MaxEncodedLen)
	/// Storage: UniversalDividend MonetaryMass (r:1 w:1)
	/// Proof: UniversalDividend MonetaryMass (max_values: Some(1), max_size: Some(8), added: 503, mode: MaxEncodedLen)
	/// Storage: UniversalDividend CurrentUdIndex (r:1 w:1)
	/// Proof: UniversalDividend CurrentUdIndex (max_values: Some(1), max_size: Some(2), added: 497, mode: MaxEncodedLen)
	fn on_initialize_ud_created() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `304`
		//  Estimated: `1789`
		// Minimum execution time: 67_003_000 picoseconds.
		Weight::from_parts(71_537_000, 0)
			.saturating_add(Weight::from_parts(0, 1789))
			.saturating_add(T::DbWeight::get().reads(6))
			.saturating_add(T::DbWeight::get().writes(2))
	}
	/// Storage: Parameters ParametersStorage (r:1 w:0)
	/// Proof Skipped: Parameters ParametersStorage (max_values: Some(1), max_size: None, mode: Measured)
	/// Storage: Membership CounterForMembership (r:1 w:0)
	/// Proof: Membership CounterForMembership (max_values: Some(1), max_size: Some(4), added: 499, mode: MaxEncodedLen)
	/// Storage: UniversalDividend NextReeval (r:1 w:1)
	/// Proof: UniversalDividend NextReeval (max_values: Some(1), max_size: Some(4), added: 499, mode: MaxEncodedLen)
	/// Storage: UniversalDividend CurrentUd (r:1 w:1)
	/// Proof: UniversalDividend CurrentUd (max_values: Some(1), max_size: Some(8), added: 503, mode: MaxEncodedLen)
	/// Storage: UniversalDividend MonetaryMass (r:1 w:1)
	/// Proof: UniversalDividend MonetaryMass (max_values: Some(1), max_size: Some(8), added: 503, mode: MaxEncodedLen)
	/// Storage: UniversalDividend PastReevals (r:1 w:1)
	/// Proof: UniversalDividend PastReevals (max_values: Some(1), max_size: Some(41), added: 536, mode: MaxEncodedLen)
	/// Storage: UniversalDividend CurrentUdIndex (r:1 w:1)
	/// Proof: UniversalDividend CurrentUdIndex (max_values: Some(1), max_size: Some(2), added: 497, mode: MaxEncodedLen)
	fn on_initialize_ud_reevalued() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `325`
		//  Estimated: `1810`
		// Minimum execution time: 96_492_000 picoseconds.
		Weight::from_parts(108_747_000, 0)
			.saturating_add(Weight::from_parts(0, 1810))
			.saturating_add(T::DbWeight::get().reads(7))
			.saturating_add(T::DbWeight::get().writes(5))
	}
	/// Storage: Identity IdentityIndexOf (r:1 w:0)
	/// Proof Skipped: Identity IdentityIndexOf (max_values: None, max_size: None, mode: Measured)
	/// Storage: Identity Identities (r:1 w:1)
	/// Proof Skipped: Identity Identities (max_values: None, max_size: None, mode: Measured)
	/// Storage: UniversalDividend CurrentUdIndex (r:1 w:0)
	/// Proof: UniversalDividend CurrentUdIndex (max_values: Some(1), max_size: Some(2), added: 497, mode: MaxEncodedLen)
	/// Storage: UniversalDividend PastReevals (r:1 w:0)
	/// Proof: UniversalDividend PastReevals (max_values: Some(1), max_size: Some(41), added: 536, mode: MaxEncodedLen)
	/// The range of component `n` is `[1, 4]`.
	fn claim_uds(n: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `627 + n * (11 ±0)`
		//  Estimated: `4092 + n * (11 ±0)`
		// Minimum execution time: 120_972_000 picoseconds.
		Weight::from_parts(135_187_750, 0)
			.saturating_add(Weight::from_parts(0, 4092))
			.saturating_add(T::DbWeight::get().reads(4))
			.saturating_add(T::DbWeight::get().writes(1))
			.saturating_add(Weight::from_parts(0, 11).saturating_mul(n.into()))
	}
	/// Storage: UniversalDividend CurrentUd (r:1 w:0)
	/// Proof: UniversalDividend CurrentUd (max_values: Some(1), max_size: Some(8), added: 503, mode: MaxEncodedLen)
	/// Storage: System Account (r:1 w:1)
	/// Proof: System Account (max_values: None, max_size: Some(161), added: 2636, mode: MaxEncodedLen)
	/// Storage: Account PendingNewAccounts (r:0 w:1)
	/// Proof Skipped: Account PendingNewAccounts (max_values: None, max_size: None, mode: Measured)
	fn transfer_ud() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `116`
		//  Estimated: `3626`
		// Minimum execution time: 185_351_000 picoseconds.
		Weight::from_parts(198_407_000, 0)
			.saturating_add(Weight::from_parts(0, 3626))
			.saturating_add(T::DbWeight::get().reads(2))
			.saturating_add(T::DbWeight::get().writes(2))
	}
	/// Storage: UniversalDividend CurrentUd (r:1 w:0)
	/// Proof: UniversalDividend CurrentUd (max_values: Some(1), max_size: Some(8), added: 503, mode: MaxEncodedLen)
	/// Storage: System Account (r:1 w:1)
	/// Proof: System Account (max_values: None, max_size: Some(161), added: 2636, mode: MaxEncodedLen)
	/// Storage: Account PendingNewAccounts (r:0 w:1)
	/// Proof Skipped: Account PendingNewAccounts (max_values: None, max_size: None, mode: Measured)
	fn transfer_ud_keep_alive() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `116`
		//  Estimated: `3626`
		// Minimum execution time: 281_525_000 picoseconds.
		Weight::from_parts(290_861_000, 0)
			.saturating_add(Weight::from_parts(0, 3626))
			.saturating_add(T::DbWeight::get().reads(2))
			.saturating_add(T::DbWeight::get().writes(2))
	}
}
